

con { timing }

  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000                                          ' use 5MHz crystal

  CLK_FREQ = ((_clkmode - xtal1) >> 6) * _xinfreq               ' system freq as a constant
  MS_001   = CLK_FREQ / 1_000                                   ' ticks in 1ms
  US_001   = CLK_FREQ / 1_000_000                               ' ticks in 1us


con { io pins }

  RX1   = 31                                                    ' programming / terminal
  TX1   = 30
  
  SDA   = 29                                                    ' eeprom / i2c
  SCL   = 28

  ' *** Inputs ***
  
  I_KeyOn = 0 '14 ' 0                                           ' ignition on, pin 0 is in car, pin 14 is in the black box
  I_Rpm = 1                                             ' rpms input
  I_AirPumpOn = 2                                       ' air pump on
  I_KeyUnlock = 3                                       ' key unlock monitor pin
  I_AirConACS = 4                                      ' air conditioning switch monitor pin  
  I_DIO =  6                                            ' mcp3204 input/output pins   
                                            '
  

  ' *** Outputs ***
  O_CLK =  5                                            ' mcp3204 clock pin 
  O_CS  =  7                                            ' mcp3204 chip select pins
  O_SimulateRpm = 15                                         ' rpm simulation code
  O_TempGauge = 16                                      ' temperature gauge pwm out                                                             


con { pst formatting }

  #1, HOME, GOTOXY, #8, BKSP, TAB, LF, CLREOL, CLRDN, CR
  #14, GOTOX, GOTOY, CLS

  
  ' universal constants

  clkFreqDivBy2 = (80000000/2)
  clkFreqDivBy3 = (80000000/3)
  clkFreqDivBy4 = (80000000/4)
  clkFreqDivBy5 = (80000000/5)
  clkFreqDivBy10 = (80000000/10)
  clkFreqDivBy20 = (80000000/20)
  clkFreqDivBy30 = (80000000/30)
  clkFreqDivBy40 = (80000000/40)
  clkFreqDivBy50 = (80000000/50)
  clkFreqDivBy100 = (80000000/100)
  clkFreqDivBy500 = (80000000/500)
  clkFreqDivBy1000 = (80000000/1000)
  clkFreqDivBy5000 = (80000000/5000)
  clkFreqDivBy10000 = (80000000/10000)

  clkFreqTimes1Point5 = (80000000 + (80000000/2))
  clkFreqTimes2 = (80000000 * 2)
  clkFreqTimes2Point5 = ((80000000 * 2) + (80000000/2))
  clkFreqTimes3 = (80000000 * 3)
  clkFreqTimes4 = (80000000 * 4)
  clkFreqTimes5 = (80000000 * 5)
  clkFreqTimes6 = (80000000 * 6)
  clkFreqTimes7 = (80000000 * 7)



  c_0FahrenheitOn = 0.99
  c_0FahrenheitOff = 0.01 
  c_5FahrenheitOn = 0.99
  c_5FahrenheitOff = 0.01 
  c_10FahrenheitOn = 0.99
  c_10FahrenheitOff = 0.01 
  c_15FahrenheitOn = 0.99
  c_15FahrenheitOff = 0.01 
  c_20FahrenheitOn = 0.99
  c_20FahrenheitOff = 0.01 
  c_25FahrenheitOn = 0.99
  c_25FahrenheitOff = 0.01 
  c_30FahrenheitOn = 0.99
  c_30FahrenheitOff = 0.01 
  c_35FahrenheitOn = 0.99
  c_35FahrenheitOff = 0.01 
  c_40FahrenheitOn = 0.99
  c_40FahrenheitOff = 0.01 
  c_45FahrenheitOn = 0.99
  c_45FahrenheitOff = 0.01 
  c_50FahrenheitOn = 0.99
  c_50FahrenheitOff = 0.01 
  c_55FahrenheitOn = 0.99
  c_55FahrenheitOff = 0.01 
  c_60FahrenheitOn = 0.99
  c_60FahrenheitOff = 0.01 
  c_65FahrenheitOn = 0.99
  c_65FahrenheitOff = 0.01 
  c_70FahrenheitOn = 0.99
  c_70FahrenheitOff = 0.01
  c_75FahrenheitOn = 0.98
  c_75FahrenheitOff = 0.02
  c_80FahrenheitOn = 0.97
  c_80FahrenheitOff = 0.03
  c_85FahrenheitOn = 0.95
  c_85FahrenheitOff = 0.05
  c_90FahrenheitOn = 0.92
  c_90FahrenheitOff = 0.08
  c_95FahrenheitOn = 0.89
  c_95FahrenheitOff = 0.11
  c_100FahrenheitOn = 0.87
  c_100FahrenheitOff = 0.13
  c_105FahrenheitOn = 0.84
  c_105FahrenheitOff = 0.16
  c_110FahrenheitOn = 0.82
  c_110FahrenheitOff = 0.18
  c_115FahrenheitOn = 0.79
  c_115FahrenheitOff = 0.21
  c_120FahrenheitOn = 0.76
  c_120FahrenheitOff = 0.24
  c_125FahrenheitOn = 0.73
  c_125FahrenheitOff = 0.27
  c_130FahrenheitOn = 0.71
  c_130FahrenheitOff = 0.29
  c_135FahrenheitOn = 0.69
  c_135FahrenheitOff = 0.31
  c_140FahrenheitOn = 0.67
  c_140FahrenheitOff = 0.33
  c_145FahrenheitOn = 0.65
  c_145FahrenheitOff = 0.35
  c_150FahrenheitOn = 0.64
  c_150FahrenheitOff = 0.36
  c_155FahrenheitOn = 0.62
  c_155FahrenheitOff = 0.38
  c_160FahrenheitOn = 0.60
  c_160FahrenheitOff = 0.40
  c_165FahrenheitOn = 0.57
  c_165FahrenheitOff = 0.43
  c_170FahrenheitOn = 0.53
  c_170FahrenheitOff = 0.47
  c_175FahrenheitOn = 0.51
  c_175FahrenheitOff = 0.49
  c_180FahrenheitOn = 0.45
  c_180FahrenheitOff = 0.55
  c_185FahrenheitOn = 0.41
  c_185FahrenheitOff = 0.59
  c_190FahrenheitOn = 0.40
  c_190FahrenheitOff = 0.60
  c_195FahrenheitOn = 0.39
  c_195FahrenheitOff = 0.61
  c_200FahrenheitOn = 0.38
  c_200FahrenheitOff = 0.62
  c_205FahrenheitOn = 0.37
  c_205FahrenheitOff = 0.63
  c_210FahrenheitOn = 0.31
  c_210FahrenheitOff = 0.69
  c_215FahrenheitOn = 0.28
  c_215FahrenheitOff = 0.72
  c_220FahrenheitOn = 0.25
  c_220FahrenheitOff = 0.75
  c_225FahrenheitOn = 0.23
  c_225FahrenheitOff = 0.77
  c_230FahrenheitOn = 0.20
  c_230FahrenheitOff = 0.80
  c_235FahrenheitOn = 0.17
  c_235FahrenheitOff = 0.83
  c_240FahrenheitOn = 0.15
  c_240FahrenheitOff = 0.85
  c_245FahrenheitOn = 0.12
  c_245FahrenheitOff = 0.88
  c_250FahrenheitOn = 0.09
  c_250FahrenheitOff = 0.91
  c_255FahrenheitOn = 0.01
  c_255FahrenheitOff = 0.99
   

  c_minimalRunningRpm = 400
  'c_liftRpm = 5400
  'c_shiftRpm = 8300

  c_byteLimit = 100


obj

  debug : "fullduplexserial64"                                   ' use Parallax Serial Terminal
  adc  : "jm_mcp3208_ez"
  n : "Numbers"
  f : "Float32Full"


var

  'pub main variables

  byte stringIn[c_byteLimit]
  long adcBits
  long adcMaxVoltage      
  long keyWaitForLow
  long keyPress1TimeStamp
  long keyPress2TimeStamp
  long keyPress3TimeStamp
  long keyPress4TimeStamp
  long trunkOpenOffTime
  long trunkSolenoidActive
  long windowOpenOffTime
  long windowRelayActive
  long mainDebug            
  long mainDebugPause
  long mainDebugPauseTime
  long i
  long adcTHWTempPrevious
  long adcTHWTemp
  long okToReadAdcTHW
'  long j 

  

  'pub coolantPwmOut variables

  long adcTHW
  long adcTHWPrevious
  long adcTHE
  long adcHP
  long adcUnknown
  long adcTPS
  long adcTHWBlock
  long onTime
  long offTime
  long coolantPwmDebug
  long coolantPwmDebugPause 
  long coolantPwmDebugPauseTime 
  long coolantPwmLastDebugTime1
  long coolantPwmLastDebugTime2
  long coolantPwmLastDebugTime3
  long airConditioningDebug
  long airConditioningNextOnTime 
  long airConditioningStateOff
  long airConditioningDebugPauseTime
  long airConditioningDebugPause
  long coolantPwmStateHigh 
  long coolantPwmOnTime
  long coolantPwmOffTime
  long coolantPwmDebugLoopOverride
  long airConDebugLoopOverride
  long firstRunAfterKeyOffCoolantPwm
  long adcRising
  long adcFalling
  long adcSimulateChangeRate

  byte coolantPwmOutCogId


  'long adc
  long adcOutputAsDecimal
  long adcOutputAsVoltage
  long pwmOutputHertzToClkCycles 


  ' Stack variables
  long coolantPwmOutStack[100]


  

pub main | t, ch, analog                            ' COG0 USED start main    


  waitcnt((clkfreq * 2) + cnt)

  coolantPwmOutCogId := Cognew(coolantPwmOut, @coolantPwmOutStack)        ' COG1 USED start coolantPwm
  
  

  debug.start(RX1, TX1, %0000, 115_200)             ' COG4 USED start terminal
  adc.start(O_CS, O_CLK, I_DIO)                     ' COG5 USED start adc driver
  f.start                                           ' COG6 USED start math driver
  adcBits := 4096
  adcMaxVoltage := 5
  


  ' initialization of variables
  t := cnt

  mainDebug := false
  mainDebugPause := cnt
  mainDebugPauseTime := clkFreqTimes2

  ' initialization of pins

  dira[I_KeyOn] ~               ' sets pin to input                                    
  dira[I_Rpm] ~
  dira[I_AirPumpOn] ~           ' Pin 2                                 
  dira[I_KeyUnlock] ~                                             
  dira[I_DIO] ~
  dira[I_AirConACS] ~


  ina[I_KeyOn] ~               ' sets the input low                                     
  ina[I_Rpm] ~                                          
  ina[I_AirPumpOn] ~           ' Pin 2                                      
  ina[I_KeyUnlock] ~                                                  
  ina[I_DIO] ~          
  ina[I_AirConACS] ~


  
  dira[O_CS] ~~                                     ' Pin 5 ' sets the pin to output
  dira[O_CLK] ~~                                    ' Pin 7
  dira[O_SimulateRpm] := 1                          ' Pin 15
  dira[O_TempGauge] ~~                              ' Pin 16                                                                         

  outa[O_CLK] ~                                     ' Pin 5 ' output low
  outa[O_CS] ~                                      ' Pin 7
  outa[O_SimulateRpm] := 0                          ' Pin 15
  outa[O_TempGauge] ~                               ' Pin 16                                                                                     

  
  pwmOutputHertzToClkCycles := (f.fdiv(f.ffloat(clkfreq), 2.45)) ' was 2.39 and 2.45 on 10-17-14
  
  debug.tx(CLS) 
  debug.str(string("EMS Assistant"))
  debug.Tx(13)
  debug.str(string("Main"))
  debug.Tx(13)



  ' initialize variables

  i := 0
  okToReadAdcTHW := 1
  adcTHWTempPrevious := 3300
   

  repeat

    
    
    
    if (ina[I_KeyOn] == 1)

      if (coolantPwmOutCogId < 0) OR (coolantPwmOutCogId > 7) 
        coolantPwmOutCogId := Cognew(coolantPwmOut, @coolantPwmOutStack)        ' COG1 USED start coolantPwm



      if (okToReadAdcTHW == 1)
        okToReadAdcTHW := 0
        adcTHWTemp := adc.read(0, adc#SE)                 ' Potentiometer number 1

        
        if (adcTHWTemp <> 0)
          adcTHWTempPrevious := adcTHWTemp
          
        else
          adcTHWTemp := adcTHWTempPrevious


        okToReadAdcTHW := 1     


    else

      if (coolantPwmOutCogId > -1) 
        Cogstop(coolantPwmOutCogId)                       ' COG1 USED start coolantPwm
        coolantPwmOutCogId := -1

        outa[I_AirConACS] := 0                            ' Pin 4
        outa[O_TempGauge] := 0                            ' Pin 16
      


    waitcnt((clkfreq/20) + cnt)    
      




pub coolantPwmOut 


 

  ' set pin states
  
  dira[I_AirConACS] := 0                            ' Pin 4  ' input
  dira[I_KeyOn] := 0                                ' Pin 0 or 14
  dira[O_TempGauge] := 1                            ' Pin 16  ' output                            


  ' set pin voltages
            
  outa[I_AirConACS] := 0                            ' Pin 4      
  outa[O_TempGauge] := 0                            ' Pin 16
  
  ' initialize variables

  coolantPwmDebug := false
  coolantPwmDebugPause := cnt
  coolantPwmDebugPauseTime := clkFreqTimes2
  coolantPwmLastDebugTime1 := 0
  coolantPwmLastDebugTime2 := 0
  coolantPwmLastDebugTime3 := 0 
  coolantPwmStateHigh := false
  coolantPwmOnTime := cnt
  coolantPwmOffTime := cnt 
  adcTHWBlock := false


  
  waitcnt((clkfreq * 1) + cnt)


  
  repeat

    if (ina[I_KeyOn] == 1)

      
      if (okToReadAdcTHW == 1)
        okToReadAdcTHW := 0
        adcTHWPrevious := adcTHW
        adcTHW := adcTHWTemp                
        okToReadAdcTHW := 1
        
 
      
      if (adcTHW <> 0)

        

        if (adcTHWBlock == false)


              
          case -1

            ((adcTHW < 4096) AND (adcTHW => 3350) AND (adcTHWBlock == false)): 'OR (adcTHW910High == true) : ' 195F = 1.11vDc or 910 ADC value (this is a guess at vDc)
              onTime := f.fmul(c_70FahrenheitOn, pwmOutputHertzToClkCycles)
              onTime := f.fround(onTime)
              offTime := f.fmul(c_70FahrenheitOff, pwmOutputHertzToClkCycles)
              offTime := f.fround(offTime)
              

                                           ' changed from 910
            ((adcTHW < 3350) AND (adcTHW => 3250) AND (adcTHWBlock == false)): 'OR (adcTHW910High == true) : ' 195F = 1.11vDc or 910 ADC value (this is a guess at vDc)
              onTime := f.fmul(c_75FahrenheitOn, pwmOutputHertzToClkCycles)
              onTime := f.fround(onTime)
              offTime := f.fmul(c_75FahrenheitOff, pwmOutputHertzToClkCycles)
              offTime := f.fround(offTime)

                          
                                           ' changed from 910
            ((adcTHW < 3250) AND (adcTHW => 3150) AND (adcTHWBlock == false)): 'OR (adcTHW910High == true) : ' 195F = 1.11vDc or 910 ADC value (this is a guess at vDc)
              onTime := f.fmul(c_80FahrenheitOn, pwmOutputHertzToClkCycles)
              onTime := f.fround(onTime)
              offTime := f.fmul(c_80FahrenheitOff, pwmOutputHertzToClkCycles)
              offTime := f.fround(offTime)
              

                                                         
            ((adcTHW < 3150) AND (adcTHW => 3050) AND (adcTHWBlock == false)): 'OR (adcTHW910High == true) : ' 195F = 1.11vDc or 910 ADC value (this is a guess at vDc)
              onTime := f.fmul(c_85FahrenheitOn, pwmOutputHertzToClkCycles)
              onTime := f.fround(onTime)
              offTime := f.fmul(c_85FahrenheitOff, pwmOutputHertzToClkCycles)
              offTime := f.fround(offTime)
              

                                                         
            ((adcTHW < 3050) AND (adcTHW => 2950) AND (adcTHWBlock == false)): 'OR (adcTHW910High == true) : ' 195F = 1.11vDc or 910 ADC value (this is a guess at vDc)
              onTime := f.fmul(c_90FahrenheitOn, pwmOutputHertzToClkCycles)
              onTime := f.fround(onTime)
              offTime := f.fmul(c_90FahrenheitOff, pwmOutputHertzToClkCycles)
              offTime := f.fround(offTime)
              

                                                                       
            ((adcTHW < 2950) AND (adcTHW => 2850) AND (adcTHWBlock == false)): 'OR (adcTHW910High == true) : ' 195F = 1.11vDc or 910 ADC value (this is a guess at vDc)
              onTime := f.fmul(c_95FahrenheitOn, pwmOutputHertzToClkCycles)
              onTime := f.fround(onTime)
              offTime := f.fmul(c_95FahrenheitOff, pwmOutputHertzToClkCycles)
              offTime := f.fround(offTime)
              

                                                                       
            ((adcTHW < 2850) AND (adcTHW => 2740) AND (adcTHWBlock == false)): 'OR (adcTHW910High == true) : ' 195F = 1.11vDc or 910 ADC value (this is a guess at vDc)
              onTime := f.fmul(c_100FahrenheitOn, pwmOutputHertzToClkCycles)
              onTime := f.fround(onTime)
              offTime := f.fmul(c_100FahrenheitOff, pwmOutputHertzToClkCycles)
              offTime := f.fround(offTime)
              

                                                                       
            ((adcTHW < 2740) AND (adcTHW => 2625) AND (adcTHWBlock == false)): 'OR (adcTHW910High == true) : ' 195F = 1.11vDc or 910 ADC value (this is a guess at vDc)
              onTime := f.fmul(c_105FahrenheitOn, pwmOutputHertzToClkCycles)
              onTime := f.fround(onTime)
              offTime := f.fmul(c_105FahrenheitOff, pwmOutputHertzToClkCycles)
              offTime := f.fround(offTime)
              

                                                                       
            ((adcTHW < 2625) AND (adcTHW => 2530) AND (adcTHWBlock == false)): 'OR (adcTHW910High == true) : ' 195F = 1.11vDc or 910 ADC value (this is a guess at vDc)
              onTime := f.fmul(c_110FahrenheitOn, pwmOutputHertzToClkCycles)
              onTime := f.fround(onTime)
              offTime := f.fmul(c_110FahrenheitOff, pwmOutputHertzToClkCycles)
              offTime := f.fround(offTime)
              

                                                                       
            ((adcTHW < 2530) AND (adcTHW => 2420) AND (adcTHWBlock == false)): 'OR (adcTHW910High == true) : ' 195F = 1.11vDc or 910 ADC value (this is a guess at vDc)
              onTime := f.fmul(c_115FahrenheitOn, pwmOutputHertzToClkCycles)
              onTime := f.fround(onTime)
              offTime := f.fmul(c_115FahrenheitOff, pwmOutputHertzToClkCycles)
              offTime := f.fround(offTime)
              
 
                                                                       
            ((adcTHW < 2420) AND (adcTHW => 2330) AND (adcTHWBlock == false)): 'OR (adcTHW910High == true) : ' 195F = 1.11vDc or 910 ADC value (this is a guess at vDc)
              onTime := f.fmul(c_120FahrenheitOn, pwmOutputHertzToClkCycles)
              onTime := f.fround(onTime)
              offTime := f.fmul(c_120FahrenheitOff, pwmOutputHertzToClkCycles)
              offTime := f.fround(offTime)
              

                                                                       
            ((adcTHW < 2330) AND (adcTHW => 2210) AND (adcTHWBlock == false)): 'OR (adcTHW910High == true) : ' 195F = 1.11vDc or 910 ADC value (this is a guess at vDc)
              onTime := f.fmul(c_125FahrenheitOn, pwmOutputHertzToClkCycles)
              onTime := f.fround(onTime)
              offTime := f.fmul(c_125FahrenheitOff, pwmOutputHertzToClkCycles)
              offTime := f.fround(offTime)
              

                                                                       
            ((adcTHW < 2210) AND (adcTHW => 2120) AND (adcTHWBlock == false)): 'OR (adcTHW910High == true) : ' 195F = 1.11vDc or 910 ADC value (this is a guess at vDc)
              onTime := f.fmul(c_130FahrenheitOn, pwmOutputHertzToClkCycles)
              onTime := f.fround(onTime)
              offTime := f.fmul(c_130FahrenheitOff, pwmOutputHertzToClkCycles)
              offTime := f.fround(offTime)
              
 
                                                                       
            ((adcTHW < 2120) AND (adcTHW => 2010) AND (adcTHWBlock == false)): 'OR (adcTHW910High == true) : ' 195F = 1.11vDc or 910 ADC value (this is a guess at vDc)
              onTime := f.fmul(c_135FahrenheitOn, pwmOutputHertzToClkCycles)
              onTime := f.fround(onTime)
              offTime := f.fmul(c_135FahrenheitOff, pwmOutputHertzToClkCycles)
              offTime := f.fround(offTime)
              
              if (coolantPwmDebug == true) AND (((cnt - coolantPwmDebugPause) > 0) OR (coolantPwmDebugLoopOverride == true)) 

                                                                       
            ((adcTHW < 2010) AND (adcTHW => 1915) AND (adcTHWBlock == false)): 'OR (adcTHW910High == true) : ' 195F = 1.11vDc or 910 ADC value (this is a guess at vDc)
              onTime := f.fmul(c_140FahrenheitOn, pwmOutputHertzToClkCycles)
              onTime := f.fround(onTime)
              offTime := f.fmul(c_140FahrenheitOff, pwmOutputHertzToClkCycles)
              offTime := f.fround(offTime)
              

                                                                       
            ((adcTHW < 1915) AND (adcTHW => 1810) AND (adcTHWBlock == false)): 'OR (adcTHW910High == true) : ' 195F = 1.11vDc or 910 ADC value (this is a guess at vDc)
              onTime := f.fmul(c_145FahrenheitOn, pwmOutputHertzToClkCycles)
              onTime := f.fround(onTime)
              offTime := f.fmul(c_145FahrenheitOff, pwmOutputHertzToClkCycles)
              offTime := f.fround(offTime)
              

                                                                       
            ((adcTHW < 1810) AND (adcTHW => 1715) AND (adcTHWBlock == false)): 'OR (adcTHW910High == true) : ' 195F = 1.11vDc or 910 ADC value (this is a guess at vDc)
              onTime := f.fmul(c_150FahrenheitOn, pwmOutputHertzToClkCycles)
              onTime := f.fround(onTime)
              offTime := f.fmul(c_150FahrenheitOff, pwmOutputHertzToClkCycles)
              offTime := f.fround(offTime)
              

                                                                       
            ((adcTHW < 1715) AND (adcTHW => 1605) AND (adcTHWBlock == false)): 'OR (adcTHW910High == true) : ' 195F = 1.11vDc or 910 ADC value (this is a guess at vDc)
              onTime := f.fmul(c_155FahrenheitOn, pwmOutputHertzToClkCycles)
              onTime := f.fround(onTime)
              offTime := f.fmul(c_155FahrenheitOff, pwmOutputHertzToClkCycles)
              offTime := f.fround(offTime)
              

                                                                       
            ((adcTHW < 1605) AND (adcTHW => 1490) AND (adcTHWBlock == false)): 'OR (adcTHW910High == true) : ' 195F = 1.11vDc or 910 ADC value (this is a guess at vDc)
              onTime := f.fmul(c_160FahrenheitOn, pwmOutputHertzToClkCycles)
              onTime := f.fround(onTime)
              offTime := f.fmul(c_160FahrenheitOff, pwmOutputHertzToClkCycles)
              offTime := f.fround(offTime)
              

                                                                       
            ((adcTHW < 1490) AND (adcTHW => 1400) AND (adcTHWBlock == false)): 'OR (adcTHW910High == true) : ' 195F = 1.11vDc or 910 ADC value (this is a guess at vDc)
              onTime := f.fmul(c_165FahrenheitOn, pwmOutputHertzToClkCycles)
              onTime := f.fround(onTime)
              offTime := f.fmul(c_165FahrenheitOff, pwmOutputHertzToClkCycles)
              offTime := f.fround(offTime)
              

                                                                       
            ((adcTHW < 1400) AND (adcTHW => 1300) AND (adcTHWBlock == false)): 'OR (adcTHW910High == true) : ' 195F = 1.11vDc or 910 ADC value (this is a guess at vDc)
              onTime := f.fmul(c_170FahrenheitOn, pwmOutputHertzToClkCycles)
              onTime := f.fround(onTime)
              offTime := f.fmul(c_170FahrenheitOff, pwmOutputHertzToClkCycles)
              offTime := f.fround(offTime)
              

                                                                       
            ((adcTHW < 1300) AND (adcTHW => 1225) AND (adcTHWBlock == false)): 'OR (adcTHW910High == true) : ' 195F = 1.11vDc or 910 ADC value (this is a guess at vDc)
              onTime := f.fmul(c_175FahrenheitOn, pwmOutputHertzToClkCycles)
              onTime := f.fround(onTime)
              offTime := f.fmul(c_175FahrenheitOff, pwmOutputHertzToClkCycles)
              offTime := f.fround(offTime)
              

                                                                       
            ((adcTHW < 1225) AND (adcTHW => 1160) AND (adcTHWBlock == false)): 'OR (adcTHW910High == true) : ' 195F = 1.11vDc or 910 ADC value (this is a guess at vDc)
              onTime := f.fmul(c_180FahrenheitOn, pwmOutputHertzToClkCycles)
              onTime := f.fround(onTime)
              offTime := f.fmul(c_180FahrenheitOff, pwmOutputHertzToClkCycles)
              offTime := f.fround(offTime)
              

                                                                       
            ((adcTHW < 1160) AND (adcTHW => 1075) AND (adcTHWBlock == false)): 'OR (adcTHW910High == true) : ' 195F = 1.11vDc or 910 ADC value (this is a guess at vDc)
              onTime := f.fmul(c_185FahrenheitOn, pwmOutputHertzToClkCycles)
              onTime := f.fround(onTime)
              offTime := f.fmul(c_185FahrenheitOff, pwmOutputHertzToClkCycles)
              offTime := f.fround(offTime)
              

                                                                       
            ((adcTHW < 1075) AND (adcTHW => 990) AND (adcTHWBlock == false)): 'OR (adcTHW910High == true) : ' 195F = 1.11vDc or 910 ADC value (this is a guess at vDc)
              onTime := f.fmul(c_190FahrenheitOn, pwmOutputHertzToClkCycles)
              onTime := f.fround(onTime)
              offTime := f.fmul(c_190FahrenheitOff, pwmOutputHertzToClkCycles)
              offTime := f.fround(offTime)
              

                                                                       
            ((adcTHW < 990) AND (adcTHW => 910) AND (adcTHWBlock == false)): 'OR (adcTHW910High == true) : ' 195F = 1.11vDc or 910 ADC value (this is a guess at vDc)
              onTime := f.fmul(c_195FahrenheitOn, pwmOutputHertzToClkCycles)
              onTime := f.fround(onTime)
              offTime := f.fmul(c_195FahrenheitOff, pwmOutputHertzToClkCycles)
              offTime := f.fround(offTime)
              

                                                                       
            ((adcTHW < 910) AND (adcTHW => 810) AND (adcTHWBlock == false)): 'OR (adcTHW910High == true) : ' 195F = 1.11vDc or 910 ADC value (this is a guess at vDc)
              onTime := f.fmul(c_200FahrenheitOn, pwmOutputHertzToClkCycles)
              onTime := f.fround(onTime)
              offTime := f.fmul(c_200FahrenheitOff, pwmOutputHertzToClkCycles)
              offTime := f.fround(offTime)
              
 
                                                                       
            ((adcTHW < 810) AND (adcTHW => 710) AND (adcTHWBlock == false)): 'OR (adcTHW910High == true) : ' 195F = 1.11vDc or 910 ADC value (this is a guess at vDc)
              onTime := f.fmul(c_205FahrenheitOn, pwmOutputHertzToClkCycles)
              onTime := f.fround(onTime)
              offTime := f.fmul(c_205FahrenheitOff, pwmOutputHertzToClkCycles)
              offTime := f.fround(offTime)
              

                                                                       
            ((adcTHW < 710) AND (adcTHW => 610) AND (adcTHWBlock == false)): 'OR (adcTHW910High == true) : ' 195F = 1.11vDc or 910 ADC value (this is a guess at vDc)
              onTime := f.fmul(c_210FahrenheitOn, pwmOutputHertzToClkCycles)
              onTime := f.fround(onTime)
              offTime := f.fmul(c_210FahrenheitOff, pwmOutputHertzToClkCycles)
              offTime := f.fround(offTime)
              

                                                                       
            ((adcTHW < 610) AND (adcTHW => 510) AND (adcTHWBlock == false)): 'OR (adcTHW910High == true) : ' 195F = 1.11vDc or 910 ADC value (this is a guess at vDc)
              onTime := f.fmul(c_215FahrenheitOn, pwmOutputHertzToClkCycles)
              onTime := f.fround(onTime)
              offTime := f.fmul(c_215FahrenheitOff, pwmOutputHertzToClkCycles)
              offTime := f.fround(offTime)
              

                                                                       
            ((adcTHW < 510) AND (adcTHW => 460) AND (adcTHWBlock == false)): 'OR (adcTHW910High == true) : ' 195F = 1.11vDc or 910 ADC value (this is a guess at vDc)
              onTime := f.fmul(c_220FahrenheitOn, pwmOutputHertzToClkCycles)
              onTime := f.fround(onTime)
              offTime := f.fmul(c_220FahrenheitOff, pwmOutputHertzToClkCycles)
              offTime := f.fround(offTime)
              

                                                                       
            ((adcTHW < 460) AND (adcTHW => 410) AND (adcTHWBlock == false)): 'OR (adcTHW910High == true) : ' 195F = 1.11vDc or 910 ADC value (this is a guess at vDc)
              onTime := f.fmul(c_225FahrenheitOn, pwmOutputHertzToClkCycles)
              onTime := f.fround(onTime)
              offTime := f.fmul(c_225FahrenheitOff, pwmOutputHertzToClkCycles)
              offTime := f.fround(offTime)
              

                                                                       
            ((adcTHW < 410) AND (adcTHW => 360) AND (adcTHWBlock == false)): 'OR (adcTHW910High == true) : ' 195F = 1.11vDc or 910 ADC value (this is a guess at vDc)
              onTime := f.fmul(c_230FahrenheitOn, pwmOutputHertzToClkCycles)
              onTime := f.fround(onTime)
              offTime := f.fmul(c_230FahrenheitOff, pwmOutputHertzToClkCycles)
              offTime := f.fround(offTime)
              

                                                                       
            ((adcTHW < 360) AND (adcTHW => 310) AND (adcTHWBlock == false)): 'OR (adcTHW910High == true) : ' 195F = 1.11vDc or 910 ADC value (this is a guess at vDc)
              onTime := f.fmul(c_235FahrenheitOn, pwmOutputHertzToClkCycles)
              onTime := f.fround(onTime)
              offTime := f.fmul(c_235FahrenheitOff, pwmOutputHertzToClkCycles)
              offTime := f.fround(offTime)
              

                                                                       
            ((adcTHW < 310) AND (adcTHW => 260) AND (adcTHWBlock == false)): 'OR (adcTHW910High == true) : ' 195F = 1.11vDc or 910 ADC value (this is a guess at vDc)
              onTime := f.fmul(c_240FahrenheitOn, pwmOutputHertzToClkCycles)
              onTime := f.fround(onTime)
              offTime := f.fmul(c_240FahrenheitOff, pwmOutputHertzToClkCycles)
              offTime := f.fround(offTime)
              

                                                                       
            ((adcTHW < 260) AND (adcTHW => 210) AND (adcTHWBlock == false)): 'OR (adcTHW910High == true) : ' 195F = 1.11vDc or 910 ADC value (this is a guess at vDc)
              onTime := f.fmul(c_245FahrenheitOn, pwmOutputHertzToClkCycles)
              onTime := f.fround(onTime)
              offTime := f.fmul(c_245FahrenheitOff, pwmOutputHertzToClkCycles)
              offTime := f.fround(offTime)

                                                                       
            ((adcTHW < 210) AND (adcTHW => 160) AND (adcTHWBlock == false)): 'OR (adcTHW910High == true) : ' 195F = 1.11vDc or 910 ADC value (this is a guess at vDc)
              onTime := f.fmul(c_250FahrenheitOn, pwmOutputHertzToClkCycles)
              onTime := f.fround(onTime)
              offTime := f.fmul(c_250FahrenheitOff, pwmOutputHertzToClkCycles)
              offTime := f.fround(offTime)
              
                                                                      
            ((adcTHW < 160) AND (adcTHW => 10) AND (adcTHWBlock == false)): 'OR (adcTHW910High == true) : ' 195F = 1.11vDc or 910 ADC value (this is a guess at vDc)
              onTime := f.fmul(c_255FahrenheitOn, pwmOutputHertzToClkCycles)
              onTime := f.fround(onTime)
              offTime := f.fmul(c_255FahrenheitOff, pwmOutputHertzToClkCycles)
              offTime := f.fround(offTime)
              

        
      if (coolantPwmStateHigh == false) AND ((cnt - coolantPwmOffTime) > 0)

        adcTHWBlock := true
        outa[O_TempGauge] := 1            
        coolantPwmOnTime := (onTime + cnt)
        coolantPwmStateHigh := true
    
           
      if (coolantPwmStateHigh == true) AND ((cnt - coolantPwmOnTime) > 0)

        adcTHWBlock := false
        outa[O_TempGauge] := 0
             
        coolantPwmOffTime := (offTime + cnt)
        coolantPwmStateHigh := false
      


    else
    
         ' commented out stuff goes here    
        
      outa[I_AirConACS] := 0                            ' Pin 4
      outa[O_TempGauge] := 0                            ' Pin 16
      adcTHWBlock := false
      okToReadAdcTHW := 1
      coolantPwmStateHigh := false
      coolantPwmOnTime := cnt
      coolantPwmOffTime := cnt
       
      firstRunAfterKeyOffCoolantPwm := true 
      
      waitcnt (clkfreq + cnt)    
      'debug.str(string("Key is off coolantPwm"))        
      


  